#
# spec file for package lighttpd (Version 1.5.x.svn.r2171)
#
# Copyright (c) 2007 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

Name:           lighttpd15-snapshot
Version:        1.5.x.svn.r2171
Release:        7.1
#
%define pkg_name lighttpd
%define pkg_name15 lighttpd15
%define pkg_user lighttpd
%define pkg_home /var/lib/%{pkg_name}
#
Group:          Productivity/Networking/Web/Servers
License:        BSD License and BSD-like
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  FastCGI-devel e2fsprogs-devel fam-devel gdbm-devel libattr-devel libmemcache-devel libxml2-devel mysql-devel openldap2-devel pcre-devel pkgconfig pwdutils zlib-devel
BuildRequires:  glib2-devel libaio-devel postgresql-devel 
%define with_tests 1
%define with_enh_webdav 1
%if 0%{?sles_version} == 9
%define with_tests 0
%define with_enh_webdav 0
%endif
%if 0%{?with_enh_webdav}
BuildRequires:  sqlite-devel >= 3
%endif
#
%if 0%{?opensuse_bs}
BuildRequires:  lua51-devel
%else
BuildRequires:  lua-devel
%endif
#
%if 0%{?with_geoip}
BuildRequires: GeoIP-devel
%endif
#
%if 0%{?with_tests}
BuildRequires:  php5-fastcgi
%endif
#
%if 0%{?sles_version} == 9
BuildRequires:  libstdc++-devel
%endif
%if 0%{?suse_version} > 1020
BuildRequires:  libbz2-devel
%endif
PreReq:         %insserv_prereq %fillup_prereq /usr/sbin/groupadd /usr/sbin/useradd
#
URL:            http://www.lighttpd.net/
Source:         lighttpd-1.5.x.tar.bz2
Source1:        %{pkg_name}.init
Source2:        %{pkg_name}.sysconfig
Source3:        config.tar.bz2
Source4:        lightytest.sh
Source5:        mod_magnet.txt
Patch1:         lighttpd-1.4.10_testsuite.patch
#
Summary:        A Secure, Fast, Compliant, and Very Flexible Web Server

%description
Lighttpd a secure, fast, compliant, and very flexible Web server that
has been optimized for high-performance environments. It has a very low
memory footprint compared to other Web servers and takes care of CPU
load.  Its advanced feature set (FastCGI, CGI, Auth,
Output-Compression, URL-Rewriting, and more) makes lighttpd the perfect
Web server software for every server that is suffering load problems.



Authors:
--------
    Jan Kneschke <jan@kneschke.de>


%package mod_magnet
Requires:       %{name} = %{version}
Group:          Productivity/Networking/Web/Servers
Summary:        A module to control the request handling in lighttpd

%description mod_magnet
A module to control the request handling in lighttpd.

It is the successor of mod_cml.



Authors:
--------
    Jan Kneschke <jan@kneschke.de>

%package mod_mysql_vhost
Requires:       %{name} = %{version}
Group:          Productivity/Networking/Web/Servers
Summary:        MySQL based virtual hosts (vhosts) module for Lighttpd

%description mod_mysql_vhost
With MySQL based vhosting you can put the information where to look for
a. document-root of a given host into a MySQL database.



Authors:
--------
    Jan Kneschke <jan@kneschke.de>


%package mod_postgresql_vhost
Requires:       %{name} = %{version}
Group:          Productivity/Networking/Web/Servers
Summary:        PgSQL based virtual hosts (vhosts) module for Lighttpd

%description mod_postgresql_vhost
With PgSQL based vhosting you can put the information where to look for
a. document-root of a given host into a PgSQL database.



Authors:
--------
    Jan Kneschke <jan@kneschke.de>

%package mod_trigger_b4_dl
Requires:       %{name} = %{version}
Group:          Productivity/Networking/Web/Servers
Summary:        Another anti hot-linking module for Lighttpd

%description mod_trigger_b4_dl
Anti Hotlinking:

* if user requests download-url directly the request is denied and
   he is redirected to ''deny-url'

* if user visits trigger-url before requesting download-url access
   is granted

* if user visits download-url again after trigger-timeout has run
   down to the request is denied and he is redirected  to deny-url

The storage for the trigger information is either stored locally in a
gdbm file or remotly in memcached.



Authors:
--------
    Jan Kneschke <jan@kneschke.de>

%package mod_rrdtool
Requires:       %{name} = %{version}
Requires:       rrdtool
Group:          Productivity/Networking/Web/Servers
Summary:        Lighttpd module to feed rrdtool databases

%description mod_rrdtool
RRD_tool is a system to store and display time-series data (i.e.
network bandwidth, machine-room temperature, server load average).

This module feeds an rrdtool database with the traffic stats from
lighttpd.



Authors:
--------
    Jan Kneschke <jan@kneschke.de>

%package mod_webdav
Requires:       %{name} = %{version}
Group:          Productivity/Networking/Web/Servers
Summary:        WebDAV module for Lighttpd

%description mod_webdav
The WebDAV module is a very minimalistic implementation of RFC 2518.
Minimalistic means that not all operations are implementated yet..

So far we have

* PROPFIND

* OPTIONS

* MKCOL

* DELETE

* PUT

and the usual GET, POST, HEAD from HTTP/1.1..

So far mounting a webdav resource into Windows XP works and the basic
litmus tests are passed.



Authors:
--------
    Jan Kneschke <jan@kneschke.de>

%debug_package
%prep
%setup -a 3 -n lighttpd-1.5.x
rm config/conf.d/cml.conf
cp %{S:5} doc/magnet.txt

%build
export CFLAGS="%{optflags} -DLDAP_DEPRECATED -D_GNU_SOURCE -W -Wmissing-prototypes -Wmissing-declarations -Wpointer-arith -Wchar-subscripts -Wformat=2 -Wbad-function-cast -std=gnu99 -g"
%if %suse_version > 1000
export CFLAGS="$CFLAGS -fstack-protector"
%endif
sh -x ./autogen.sh
%configure                      \
    --bindir=%{_sbindir}        \
    --libdir=%{_libdir}/%{pkg_name15} \
    --enable-lfs                \
    --enable-ipv6               \
    --with-ldap                 \
    --with-mysql                \
    --with-openssl              \
    --with-kerberos5            \
    --with-postgresql           \
    --with-valgrind             \
    --with-gdbm                 \
    --with-lua                  \
    --with-memcache             \
    --with-bzip2                \
    --with-webdav               \
%if 0%{?with_enh_webdav}
    --with-webdav-props         \
    --with-webdav-locks         \
%endif
    --with-fam                  \
    --with-attr
%{__make}
%if 0%{?with_tests}
#sh -x %{S:4}
%endif

%install
%makeinstall
%{__install} -d -m 0755                            \
    %{buildroot}%{pkg_home}/sockets/               \
    %{buildroot}%{_var}/cache/%{pkg_name}/compress \
    %{buildroot}%{_var}/log/%{pkg_name}            \
    %{buildroot}%{_sysconfdir}/%{pkg_name15}
#
# init script
#
%{__install} -D -m 0755 %{S:1} \
    %{buildroot}%{_sysconfdir}/init.d/%{pkg_name15}
%{__ln_s} -f %{_sysconfdir}/init.d/%{pkg_name15} %{buildroot}%{_sbindir}/rc%{pkg_name15}
#
# sample config
#
perl -p -i.orig -e 's|^(server\.tag = ).*$|$1 "%{pkg_name} (%{version}/SuSE)"|' config/lighttpd.conf
diff -ur config/lighttpd.conf{.orig,} ||:
%{__rm} -vf config/lighttpd.conf.orig ||:
%{__cp} -rv config/* %{buildroot}%{_sysconfdir}/%{pkg_name15}/
# only needed when build with mod_geoip support
%if ! 0%{?with_geoip}
%{__rm} -v %{buildroot}%{_sysconfdir}/%{pkg_name15}/conf.d/geoip.conf
%endif
#
# sysconfig template
#
%{__install} -D -m 0644 %{S:2} \
    %{buildroot}/var/adm/fillup-templates/sysconfig.%{pkg_name}-15
#
# susefirewall config file
#
%if 0%{?with_susefirewall_config}
%{__install} -D -m 0644 %{S:5} \
    %{buildroot}/etc/sysconfig/SuSEfirewall2.d/services/lighttpd
%endif
#
# remove the .la files. we dont need them.
#
%{__rm} -vf %{buildroot}%{_libdir}/%{pkg_name15}/*.la
#
# Temporarily: we rename all binaries and manpages to make it installable next to a plain 1.4
#
for f in fcgi-stat-accel lighttpd spawn-fcgi ; do
   %{__mv} -v %{buildroot}%{_sbindir}/${f}{,15}
   if [ -e %{buildroot}%{_mandir}/man1/${f}.1 ] ; then
     %{__mv} -v %{buildroot}%{_mandir}/man1/${f}{,15}.1
   fi
done

%clean
%{__rm} -rf %{buildroot};

%pre
#
# e.g. adding user
#
/usr/sbin/groupadd -r %{pkg_user} &>/dev/null ||:
/usr/sbin/useradd  -g %{pkg_user} -s /bin/false -r -c "user for %{pkg_user}" -d %{pkg_home} %{pkg_user} &>/dev/null ||:

%post
%fillup_only -n %{pkg_name} -s 15

%preun
#stop_on_removal %{pkg_name}

%postun
#restart_on_update %{pkg_name}
%{insserv_cleanup}

%files
%defattr(-,root,root,-)
%{_sbindir}/*
%dir               %attr(750,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}
%dir               %attr(750,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d
%dir               %attr(750,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/vhosts.d
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/lighttpd.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/modules.conf
# modules config
%if 0%{?with_geoip}
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/geoip.conf
%endif
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/access_log.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/auth.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/cgi.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/compress.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/debug.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/dirlisting.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/evhost.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/expire.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/fastcgi.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/mime.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/mod.template
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/proxy.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/scgi.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/secdownload.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/simple_vhost.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/ssi.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/status.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/userdir.conf
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/vhosts.d/vhosts.template
# modules
%dir %{_libdir}/%{pkg_name15}
%{_libdir}/%{pkg_name15}/mod_access.so
%{_libdir}/%{pkg_name15}/mod_accesslog.so
%{_libdir}/%{pkg_name15}/mod_alias.so
%{_libdir}/%{pkg_name15}/mod_auth.so
%{_libdir}/%{pkg_name15}/mod_cgi.so
%{_libdir}/%{pkg_name15}/mod_compress.so
%{_libdir}/%{pkg_name15}/mod_dirlisting.so
%{_libdir}/%{pkg_name15}/mod_evasive.so
%{_libdir}/%{pkg_name15}/mod_evhost.so
%{_libdir}/%{pkg_name15}/mod_expire.so
#%{_libdir}/%{pkg_name15}/mod_extforward.so
#%{_libdir}/%{pkg_name15}/mod_fastcgi.so
%{_libdir}/%{pkg_name15}/mod_flv_streaming.so
%{_libdir}/%{pkg_name15}/mod_indexfile.so
#%{_libdir}/%{pkg_name15}/mod_proxy.so
%{_libdir}/%{pkg_name15}/mod_redirect.so
%{_libdir}/%{pkg_name15}/mod_rewrite.so
#%{_libdir}/%{pkg_name15}/mod_scgi.so
%{_libdir}/%{pkg_name15}/mod_secdownload.so
%{_libdir}/%{pkg_name15}/mod_setenv.so
%{_libdir}/%{pkg_name15}/mod_simple_vhost.so
%{_libdir}/%{pkg_name15}/mod_ssi.so
%{_libdir}/%{pkg_name15}/mod_staticfile.so
%{_libdir}/%{pkg_name15}/mod_status.so
%{_libdir}/%{pkg_name15}/mod_userdir.so
%{_libdir}/%{pkg_name15}/mod_usertrack.so
%{_libdir}/%{pkg_name15}/mod_chunked.so
%{_libdir}/%{pkg_name15}/mod_deflate.so
%{_libdir}/%{pkg_name15}/mod_proxy_backend_ajp13.so
%{_libdir}/%{pkg_name15}/mod_proxy_backend_fastcgi.so
%{_libdir}/%{pkg_name15}/mod_proxy_backend_http.so
%{_libdir}/%{pkg_name15}/mod_proxy_backend_scgi.so
%{_libdir}/%{pkg_name15}/mod_proxy_core.so
%{_libdir}/%{pkg_name15}/mod_sql_vhost_core.so
%{_libdir}/%{pkg_name15}/mod_uploadprogress.so

%{_mandir}/man1/*.1*
%config(noreplace) %{_sysconfdir}/init.d/%{pkg_name15}
%doc AUTHORS ChangeLog NEWS README
%doc doc/*.dot
%doc doc/spawn-php.sh
%doc doc/accesslog.txt
%doc doc/access.txt
%doc doc/alias.txt
%doc doc/authentication.txt
%doc doc/cgi.txt
%doc doc/compress.txt
%doc doc/configuration.txt
%doc doc/expire.txt
#%doc doc/fastcgi-state.txt
#%doc doc/fastcgi.txt
%doc doc/features.txt
%doc doc/performance.txt
%doc doc/plugins.txt
#%doc doc/proxy.txt
%doc doc/redirect.txt
%doc doc/rewrite.txt
#%doc doc/scgi.txt
%doc doc/secdownload.txt
%doc doc/security.txt
%doc doc/setenv.txt
%doc doc/simple-vhost.txt
%doc doc/skeleton.txt
%doc doc/ssi.txt
%doc doc/ssl.txt
%doc doc/state.txt
%doc doc/status.txt
%doc doc/traffic-shaping.txt
%doc doc/userdir.txt
/var/adm/fillup-templates/sysconfig.%{pkg_name}-15
%dir %attr(751,%{pkg_user},%{pkg_user}) %{pkg_home}/
%dir %attr(751,%{pkg_user},%{pkg_user}) %{pkg_home}/sockets/
%attr(751,%{pkg_user},%{pkg_user}) %{_var}/cache/%{pkg_name}/
%dir %attr(750,%{pkg_user},%{pkg_user}) %{_var}/log/%{pkg_name}/

%files mod_rrdtool
%defattr(-,root,root,-)
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/rrdtool.conf
%doc doc/rrdtool.txt
%doc doc/rrdtool-graph.sh
%{_libdir}/%{pkg_name15}/mod_rrdtool.so

%files mod_magnet
%defattr(-,root,root,-)
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/magnet.conf
%{_libdir}/%{pkg_name15}/mod_magnet.so
%doc doc/magnet.txt

%files mod_mysql_vhost
%defattr(-,root,root,-)
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/mysql_vhost.conf
%{_libdir}/%{pkg_name15}/mod_mysql_vhost.so
#%doc doc/mysqlvhost.txt

%files mod_postgresql_vhost
%defattr(-,root,root,-)
#%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/pgsql_vhost.conf
%{_libdir}/%{pkg_name15}/mod_postgresql_vhost.so
#%doc doc/postgresqlvhost.txt

%files mod_trigger_b4_dl
%defattr(-,root,root,-)
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/trigger_b4_dl.conf
%{_libdir}/%{pkg_name15}/mod_trigger_b4_dl.so
%doc doc/trigger_b4_dl.txt

%files mod_webdav
%defattr(-,root,root,-)
%config(noreplace) %attr(640,root,%{pkg_user}) %{_sysconfdir}/%{pkg_name15}/conf.d/webdav.conf
%{_libdir}/%{pkg_name15}/mod_webdav.so
%doc doc/webdav.txt

%changelog
* Tue Aug 19 2008 jg@internetx.de
- update to r2282
* Wed May 21 2008 mrueckert@suse.de
- update to r2171
* Wed May 14 2008 jg@internetx.de
- update to r2169
* Tue Apr 15 2008 mrueckert@suse.de
- update to r2146
* Thu Feb 21 2008 mrueckert@suse.de
- update to r2077
* Wed Oct 17 2007 mrueckert@suse.de
- update to r2001
* Wed Sep 19 2007 mrueckert@suse.de
- update to r2000
* Wed Aug 29 2007 mrueckert@suse.de
- update to r1978
* Mon May 21 2007 mrueckert@suse.de
- update to r1857
* Wed May 16 2007 mrueckert@suse.de
- update to r1856
* Mon May 14 2007 mrueckert@suse.de
- synced with other packages
* Fri May 11 2007 mrueckert@suse.de
- update to r1854
* Wed May  9 2007 mrueckert@suse.de
- update to r1851
* Tue May  8 2007 mrueckert@suse.de
- update to r1847
* Sat May  5 2007 mrueckert@suse.de
- added lighttpd-1.5-mod_status.query_string.patch:
  adds the query string in the mod_status output.
- fixed permissions
- fixed debug package
* Thu Apr 26 2007 mrueckert@suse.de
- initial package of r1820
